#include "game.h"
/* --------------------------------------------------------------------------------- */
void initGame() {
	u8 i;
	//gameState.ptr = 0;
	gameState.ptr = 16;			//pointer in center at start of the game
	gameState.dirX = DIR_RIGHT;
	gameState.dirY = DIR_DOWN;
	for(i = 0; i < 33; i++) {
		gameState.matrix[i] = LED_STATE_1;
		//gameState.matrix[i] = LED_STATE_0;
	}
	gameState.matrix[16] = 0;	//center field is empty
	//gameState.matrix[16] = 1;
	//gameState.matrix[9] = 1;
	gameState.isGame = 1;
	demoState.isDemo = 0;
	saveState();
}
/* --------------------------------------------------------------------------------- */	
void saveState() {
	memcpy(&gameStateTemp, &gameState, sizeof(struct GameState));
}
/* --------------------------------------------------------------------------------- */
void makeCapture(u8 idx) {
	
	u8 rem = MOVES[gameState.ptr][idx];
	u8 next = MOVES[rem][idx];

	if(gameState.matrix[gameState.ptr] == LED_STATE_1 && 
			gameState.matrix[rem] == LED_STATE_1 && 
			gameState.matrix[next] == LED_STATE_0 && 
			rem != next) {
		gameState.matrix[rem] = LED_STATE_0;
		gameState.matrix[gameState.ptr] = LED_STATE_0;
		gameState.matrix[next] = LED_STATE_1;
		gameState.ptr = next;
	}
}
/* --------------------------------------------------------------------------------- */
u8 isEndGame() {
	u8 cnt = 0, i;
	for(i = 0; i < 33; i++) 
		if(gameState.matrix[i] == LED_STATE_1)
			cnt++;
	if(cnt == 1)
		return 1;
	return 0;
}	
/* --------------------------------------------------------------------------------- */
void eventToGameMove() {
	u8 key;
	//--------------------------------------------------------------------
	if(keysState[STATE_S2_IDX].fpl) {
		initGame();	//restart game
	}
	else if(keysState[STATE_S2_IDX].fp) {
	}
	else if(keysState[STATE_S2_IDX].fr) {
		memcpy(&gameState, &gameStateTemp, sizeof(struct GameState));
	}
	//--------------------------------------------------------------------	
	if(keysState[STATE_S1S4_IDX].fpl) {
		return;
	}
	else if(keysState[STATE_S1S4_IDX].fp) {
		saveState();
		if(gameState.dirC == CAPH) {
			if(gameState.dirX == DIR_RIGHT) {
				makeCapture(0);	//R
			} else {
				makeCapture(1);	//L
			}
		} else {
			if(gameState.dirY == DIR_UP) {
				makeCapture(2);	//UP
			} else {
				makeCapture(3); 	//DOWN
			}			
		}			
		return;
	} else if(keysState[STATE_S1S4_IDX].fr) {
		return;
	}
//------- mapping event to game operation ----------------------------
	if(keysState[STATE_S1_IDX].fpl) {
		gameState.dirY = ~gameState.dirY;
	}
	else if(keysState[STATE_S1_IDX].fp) {
		gameState.dirC = CAPV;
	}
	else if(keysState[STATE_S1_IDX].fr) {
		if(gameState.dirY == DIR_UP) {
			gameState.ptr = MOVES[gameState.ptr][MOVU_IDX];	//move to right
		} else {
			gameState.ptr = MOVES[gameState.ptr][MOVD_IDX];	//move to left			
		}
	}
//--------------------------------------------------------------------
	if(keysState[STATE_S4_IDX].fpl) {
		gameState.dirX = ~gameState.dirX;
	}
	else if(keysState[STATE_S4_IDX].fp) {
		gameState.dirC = CAPH;
	}
	else if(keysState[STATE_S4_IDX].fr) {
		if(gameState.dirX == DIR_RIGHT) {
			gameState.ptr = MOVES[gameState.ptr][MOVR_IDX];	//move to right
		} else {
			gameState.ptr = MOVES[gameState.ptr][MOVL_IDX];	//move to left			
		}
	}
}
/* --------------------------------------------------------------------------------- */	
void handleGame() {
	if(gameState.isGame) {
		eventToGameMove();
		showMatrix(gameState.matrix, gameState.ptr);
		if(isEndGame() == 1) {
			initDemo();
		}	
	}
}
/* --------------------------------------------------------------------------------- */